'   "AVZ DeQuarantine"

Option Explicit
Dim oShell, oFSO, curPath, AppData, SendTo, InstFolder, AppLink, AppName, AppPath, oFile, oTS, str, StartMenuPrograms, SysRoot
Dim StartMenuLink_1, StartMenuLink_2, StartMenuLink_3, StartMenuLink_4, StartMenuLink_5, EditorPath, txtClass, MsgFinish, AssocKey, OSVer, IsWin8AndLater

Set oShell     = CreateObject("WScript.Shell")
Set oFSO       = CreateObject("Scripting.FileSystemObject")

AppName = "AVZ DeQuarantine by Dragokas"
SendTo = oShell.SpecialFolders("SendTo")
AppData = oShell.SpecialFolders("AppData")
StartMenuPrograms = oShell.SpecialFolders("Programs")
SysRoot = oShell.ExpandEnvironmentStrings("%SystemRoot%")

' 
InstFolder = AppData & "\AVZ DeQuarantine"
AppPath = InstFolder & "\" & "AVZ -  .cmd"

On Error Resume Next
OSVer = Replace(oShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\CurrentVersion"),".",",")
if Len(OSVer) = 0 then OSVer = "0"
IsWin8AndLater = (CSng(OSVer) > 6.1)
On Error Goto 0

if WScript.Arguments.Count > 0 then
	if StrComp(WScript.Arguments(0), "AssocInstall", 1) = 0 then
		InstallZipAssoc
		msgbox "OK.",,AppName
		WScript.Quit
	elseif StrComp(WScript.Arguments(0), "AssocUnInstall", 1) = 0 then
		UnInstallZipAssoc
		msgbox "OK.",,AppName
		WScript.Quit
	end if
end if

AppLink = SendTo & "\" & "AVZ -  .lnk"

StartMenuLink_1 = StartMenuPrograms & "\AVZ DeQuarantine\AVZ DeQuarantine.lnk"
StartMenuLink_2 = StartMenuPrograms & "\AVZ DeQuarantine\.lnk"
StartMenuLink_3 = StartMenuPrograms & "\AVZ DeQuarantine\ AVZ DeQuarantine.lnk"
StartMenuLink_4 = StartMenuPrograms & "\AVZ DeQuarantine\quarantine.zip -  .lnk"
StartMenuLink_5 = StartMenuPrograms & "\AVZ DeQuarantine\quarantine.zip -  .lnk"

'    -    .txt
EditorPath = oShell.ExpandEnvironmentStrings(RemoveArgument(GetDefaultAppString("txt")))
if not oFSO.FileExists(EditorPath) then
	EditorPath = SysRoot & "\notepad.exe"
end if

curPath = oFSO.GetParentFolderName(WScript.ScriptFullname)

'  
if oFSO.FileExists(curPath & "\bin\AVZ -  .cmd") then
	Set oFile = oFSO.GetFile(curPath & "\bin\AVZ -  .cmd")
    Set oTS   = oFile.OpenAsTextStream(1)
    Do While Not oTS.AtEndOfStream
        str = oTS.ReadLine()
        if instr(1, str, "AppVersion", 1) <> 0 then
			AppName = AppName & " ver." & mid(str, instr(str, "=") + 1)
			exit Do
		end if
    Loop
	oTS.Close
    set oTS = Nothing: set oFile = Nothing
end if

' UnInstaller
if oFSO.FileExists(InstFolder & "\AVZ -  .cmd") then
	if msgbox("AVZ DeQuarantine  .   ?", vbYesNo, AppName) = vbYes then
		on error resume next
        oShell.CurrentDirectory = SysRoot

		if not IsWin8AndLater then
			UnInstallZipAssoc
		end if

        if oFSO.FileExists(AppLink) then oFSO.DeleteFile AppLink, true
        if oFSO.FolderExists(StartMenuPrograms & "\AVZ DeQuarantine") then
            oFSO.DeleteFolder StartMenuPrograms & "\AVZ DeQuarantine", true
        end if
        err.Clear
		if oFSO.FolderExists(InstFolder) then oFSO.DeleteFolder InstFolder, true
		if err.Number <> 0 then
			msgbox "  : " & InstFolder,, AppName
			oShell.Run "explorer.exe " & """" & InstFolder & """"
		else
			msgbox "AVZ DeQuarantine  .", 0, AppName
		end if
	end if
	WScript.Quit
end if

',     
if not oFSO.FileExists(curPath & "\bin\AVZ -  .cmd") then
	MsgBox "      .",, AppName
	WScript.Quit
end if

'    
if not oFSO.FolderExists(InstFolder) then oFSO.CreateFolder InstFolder

'  
oFSO.CopyFile curPath & "\bin\*", InstFolder & "\", true
oFSO.CopyFile WScript.ScriptFullName, InstFolder & "\AVZ DeQuarantine ().vbs", true
oShell.Run "cmd.exe /c ""<NUL set /p=>""" & InstFolder & "\7za.exe" & """:Zone.Identifier:$DATA""", 0, false
oShell.Run "cmd.exe /c ""<NUL set /p=>""" & InstFolder & "\AssocZip_Handler.vbs" & """:Zone.Identifier:$DATA""", 0, false
oShell.Run "cmd.exe /c ""<NUL set /p=>""" & InstFolder & "\AVZ -  .cmd" & """:Zone.Identifier:$DATA""", 0, false

'    SendTo ( )
with oShell.CreateShortcut(AppLink)
	.Description        = AppName
	.IconLocation       = InstFolder & "\" & ".ico"
	.TargetPath         = AppPath
	.WorkingDirectory   = InstFolder
	.Save
end with

if vbYes =  msgbox ("      ?", vbYesNo, AppName) then
  '     (  + )
  if not oFSO.FolderExists(StartMenuPrograms & "\AVZ DeQuarantine") then
	oFSO.CreateFolder StartMenuPrograms & "\AVZ DeQuarantine"
  end if

  with oShell.CreateShortcut(StartMenuLink_1)
	.Description        = AppName
	.IconLocation       = InstFolder & "\" & ".ico"
	.TargetPath         = AppPath
	.WorkingDirectory   = InstFolder
	.Save
  end with
  with oShell.CreateShortcut(StartMenuLink_2)
	.Description        = " " & AppName
	.IconLocation       = EditorPath
	.TargetPath         = EditorPath
    .Arguments          = """" & AppPath & """"
	.WorkingDirectory   = InstFolder
	.Save
  end with
  with oShell.CreateShortcut(StartMenuLink_3)
	.Description        = " " & AppName
	.TargetPath         = InstFolder & "\AVZ DeQuarantine ().vbs"
	.WorkingDirectory   = InstFolder
	.Save
  end with
if not IsWin8AndLater then
  with oShell.CreateShortcut(StartMenuLink_4)
	.Description        = "    quarantine*.zip"
	.TargetPath         = "wscript.exe"
	.Arguments          = """" & InstFolder & "\AVZ DeQuarantine ().vbs" & """" & " " & "AssocInstall"
	.WorkingDirectory   = InstFolder
	.Save
  end with
  with oShell.CreateShortcut(StartMenuLink_5)
	.Description        = "     *quarantine*.zip"
	.TargetPath         = "wscript.exe"
	.TargetPath         = "wscript.exe"
	.Arguments          = """" & InstFolder & "\AVZ DeQuarantine ().vbs" & """" & " " & "AssocUnInstall"
	.WorkingDirectory   = InstFolder
	.Save
  end with
end if
  MsgFinish = "    """""
end if

if not IsWin8AndLater then
  if vbYes = Msgbox ("     *quarantine*.zip ?", vbYesNo, AppName) then
	InstallZipAssoc
  end if
end if

if vbYes = Msgbox ("     """" (SendTo)" & MsgFinish & "." & vbCrLf & vbCrLf & _
	   "    :" & vbCrLf & InstFolder & vbCrLf & vbCrLf & _
       "      ?", vbYesNo, AppName) then

	oShell.Run """" & EditorPath & """" & " " & """" & AppPath & """", 1, false

end if

Set oShell = Nothing: Set oFSO = Nothing

'     quarantine*.zip
Sub InstallZipAssoc()
	Dim OldAssocClass

	On Error Resume Next
	'is already installed
	if (0 <> Len(oShell.RegRead ("HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\shell\open\command\"))) then 
		UnInstallZipAssoc
	end if
	
	'read current zip application class if exists
	OldAssocClass = oShell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice\ProgID")

	'rewrite app class by own
	Err.Clear
	oShell.RegWrite "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice\ProgID", "Applications\AVZ.DeQuarantine", "REG_SZ"

	if Err.Number <> 0 then
		RegKeyResetSecurity
		Err.Clear
		oShell.RegWrite "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice\ProgID", "Applications\AVZ.DeQuarantine", "REG_SZ"
		if Err.Number <> 0 then
			msgbox "!    . :       ."
		end if
	end if

	'write execution string for own application class including old info (old app class and old execution string as arguments)
	'1.  wscript.exe
	'2.  AssocZip_Handler.vbs -> it directs quarantine*.zip files into new app class execution string, and the rest into the old execution string
	'3.  %1
	'4.  OldAssocClass
	oShell.RegWrite "HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\shell\open\command\", _
		"wscript.exe" & " " & """" & InstFolder & "\AssocZip_Handler.vbs" & """" & " " & """" & "%1" & """" & " " & """" & OldAssocClass & """", _
		"REG_EXPAND_SZ"
End Sub

'    quarantine*.zip
Sub UnInstallZipAssoc()
	On Error Resume Next
	Dim AssocKey, pos, cnt, NewAssocString, OldAssocClass, qt1, qt2, CurAssocClass

	NewAssocString = oShell.RegRead ("HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\shell\open\command\")

	CurAssocClass = oShell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice\ProgID")

	'is it still own app class for zip assoc.?
	if CurAssocClass = "Applications\AVZ.DeQuarantine" then
		'is installed
		if (0 <> Len(NewAssocString)) then
			pos = 0
			Do
				cnt = cnt + 1
				pos = pos + 1
				pos = instr(pos, NewAssocString, """")
				if pos <> 0 then
					Select case Cnt
					case 5
						qt1 = pos
					case 6
						qt2 = pos
						if qt2 - qt1 <> 1 then 'not empty
							OldAssocClass = mid(NewAssocString, qt1 + 1, qt2 - qt1 - 1)
							oShell.RegWrite "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice\ProgID", OldAssocClass, "REG_SZ"
						end if
					End Select
				end if
			Loop Until pos = 0
	    end if
		'if last time UserChoice app class wasn't defined
		if 0 = Len(OldAssocClass) then oShell.RegDelete "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice\ProgID"
	end if
	
	'removing own app class
	oShell.RegDelete "HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\shell\open\command\"
	oShell.RegDelete "HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\shell\open\"
	oShell.RegDelete "HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\shell\"
	oShell.RegDelete "HKEY_CURRENT_USER\Software\Classes\Applications\AVZ.DeQuarantine\"
End Sub

'      
Function GetDefaultAppString(Extension)
	On Error Resume Next
	Dim txtClass, file
	txtClass = oShell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\." & Extension & "\UserChoice\ProgID")
	if 0 <> Len(txtClass) then
		file = oShell.RegRead("HKEY_CLASSES_ROOT\" & txtClass & "\shell\open\command\")
	end if
	if 0 = len(file) then
		txtClass = oShell.RegRead("HKEY_CLASSES_ROOT\." & Extension & "\")
		if 0 <> len(txtClass) then
			file = oShell.RegRead("HKEY_CLASSES_ROOT\" & txtClass & "\shell\open\command\")
		end if
	end if
	GetDefaultAppString = file
End Function

'    
Function RemoveArgument(sPath)
	Dim tmp, pos, ret
	tmp = trim(sPath)
	if left(tmp, 1) = """" then
		pos = instr(2, tmp, """")
        if pos <> 0 then 
			ret = mid(tmp, 2, pos - 2)
		else
			ret = mid(tmp, 2)
		end if
	else
		pos = instr(tmp, " ")
		if pos <> 0 then
			ret = Left(tmp, pos - 1)
		else
			ret = tmp
		end if
	end if
	RemoveArgument = ret
End Function

Sub RegKeyResetSecurity()
'On Error Resume Next
Dim oWMI, UC, oStdReg, CurSID, AdmSID, objSD, SID, i

Const FILE_WRITE_DATA = 2
Const ACE_ALLOW = 0
Const ACE_DENY = 1
Const HKCU = &H80000001

UC = "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.zip\UserChoice"

'set oShell = CreateObject("WScript.Shell")

Set oStdReg = GetObject("winmgmts:{impersonationLevel=Impersonate, (Security)}!\\.\root\default:StdRegProv") ' grant SeSecurityPrivilege

Set oWMI = GetObject("winmgmts:\\.\Root\CIMV2")

CurSID = oWMI.Get("Win32_UserAccount.Domain='" & oShell.ExpandEnvironmentStrings("%UserDomain%") & "',Name='" & oShell.ExpandEnvironmentStrings("%UserName%") & "'").SID
AdmSID = "S-1-5-32-544"

'Set objSD = oWMI.Get("Win32_SecurityDescriptor").SpawnInstance_()

oStdReg.GetSecurityDescriptor HKCU, UC, objSD

If Not IsNull(objSD.DACL) Then

	For i = 0 to UBound(objSD.DACL)

		SID = objSD.DACL(i).Trustee.SIDString

		if ((SID = CurSID) or (SID = AdmSID)) then

			if (objSD.DACL(i).AccessMask And FILE_WRITE_DATA) then

				if (objSD.DACL(i).AceType = ACE_DENY) then
					
					objSD.DACL(i).AceType = ACE_ALLOW

				end if
			end if
		end if
	next
end if

oStdReg.SetSecurityDescriptor HKCU, UC, objSD

set oStdReg = Nothing
set oWMI = Nothing
End Sub